HDU 2857 Mirror and Light

/*
hdu 2857 Mirror and Light
计算几何
镜面反射
*/
#include<stdio.h>
#include<string.h>
#include<math.h>
#include<algorithm>
using namespace std;
const double DNF=100000001.0;
int t;
double x1,x2,y11,y2,xs,ys,xe,ye;
struct Point
{
    double x;
    double y;
};
struct Line
{
    double a;
    double b;
    double c;
};

Point get_point1(Line x,Line y)
{
    return (Point){ (x.b*y.c-y.b*x.c)/(x.a*y.b-y.a*x.b) , (y.a*x.c-x.a*y.c)/(x.a*y.b-y.a*x.b) };
}

Point extent1(Point a,Point b)
{
    return (Point){2*b.x-a.x,2*b.y-a.y};
}

Line get_line1(Point a,Point b)
{
    return (Line){ a.y-b.y , b.x-a.x , a.y*(a.x-b.x)-a.x*(a.y-b.y) };
}

Line get_line1(Point a,Line x)
{
    return (Line){ -x.b , x.a , x.b*a.x-x.a*a.y };
}

int main()
{
    //freopen("1005.in","r",stdin);
    scanf("%d",&t);
    Point ans;
    Point s,e,tmp,m1,m2,news;
    Line a,b,c;
    while(t--)
    {
        scanf("%lf%lf%lf%lf%lf%lf%lf%lf",&x1,&y11,&x2,&y2,&xs,&ys,&xe,&ye);
        m1.x=x1;m1.y=y11;
        m2.x=x2;m2.y=y2;
        s=(Point){xs,ys},e=(Point){xe,ye};
        //get
        b=get_line1(m1,m2);
        a=get_line1(s,b);

        tmp=get_point1(a,b);
        news=extent1(s,tmp);
        c=get_line1(news,e);
        ans=get_point1(c,b);
        if(fabs(ans.x-0.000)<1e-6)
            ans.x=0.000;
        if(fabs(ans.y-0.000)<1e-6)
            ans.y=0.000;
        printf("%.3lf %.3lf\n",ans.x,ans.y);
    }
    return 0;
}
时间: 2024-10-25 18:55:37

HDU 2857 Mirror and Light的相关文章

HDOJ 题目2857 Mirror and Light(关于直线对称点,直线交点)

Mirror and Light Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 32768/32768K (Java/Other) Total Submission(s) : 1   Accepted Submission(s) : 1 Problem Description The light travels in a straight line and always goes in the minimal path betwee

hdu 2857 点在直线上的投影+直线的交点

Mirror and Light Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 814    Accepted Submission(s): 385 Problem Description The light travels in a straight line and always goes in the minimal path b

题解 HDU 3698 Let the light guide us Dp + 线段树优化

http://acm.hdu.edu.cn/showproblem.php?pid=3698 Let the light guide us Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 62768/32768 K (Java/Others) Total Submission(s): 759    Accepted Submission(s): 253 Problem Description Plain of despair was

Mirror and Light (点与直线)

Mirror and Light Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 821    Accepted Submission(s): 387 Problem Description The light travels in a straight line and always goes in the minimal path

HDU 3698 Let the light guide us

Let the light guide us Time Limit: 2000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 369864-bit integer IO format: %I64d      Java class name: Main Plain of despair was once an ancient battlefield where those brave spirits

【HDU 1687】Lucky Light(思维+计算几何)

传送门:http://acm.hdu.edu.cn/showproblem.php?pid=1687 题意:有一个光源,下面有很多放置的板子,问光线被板子分割之后在地上能产生多少块亮区(看题中的图就能看懂). 分析:这个题的做法和省选第一天的C题很像,由于是求在地面上,也就是一条直线上的亮区,我们可以求出地面上被木板遮挡形成的暗区的左坐标和右坐标,然后合并区间就可以了.而求地面上的坐标,可以用相似三角形,若光源为(sx,sy),点为(x1,y1)和(x2,y2),则地面上的坐标为:sx-(sx-

hdu 2857 求点关于线段的对称点

本来很简单的一个题,但是有个大坑: 因为模板中Tline用到了直线的一般方程ax+by+c=0,所以有种很坑的情况需要特判: 斜率不存在啊喂 老子坑了一下午2333 1 #include <math.h> 2 #include <stdio.h> 3 4 #define eps 1e-6 5 #define PI acos(-1.0)//3.14159265358979323846 6 //判断一个数是否为0,是则返回true,否则返回false 7 #define zero(x)

HDU 4276-The Ghost Blows Light(树状背包)

题意: n个房间,每个有一定的钱,一个房间到另一个房间花费一定的时间,给你房间连接树,求在t时间内到达房间m能得到的最大钱数(从房间1(根)出发) 分析: 该题关键是最后要到达m,没有这个条件,就是基础的树形背包,哎,一开始没思路,放了一段时间,看看题解才明白,该题突破口,就是,你先想怎么判断不能到到达m的情况,自然想到最短路,对树先求一次最短路,在最短路上的点只能,过一次,其他得点过两次,把最短路上的点花费置零,剩下的就是基础的树形背包. #include <map> #include &l

CDQ分治题目小结

CDQ分治属于比较特殊的一类分治,许多问题转化为这类分治的时候,时空方面都会有很大节省,而且写起来没有这么麻烦. 这类分治的特殊性在于分治的左右两部分的合并,作用两部分在合并的时候作用是不同的,比如,通过左半部分的影响来更新右半部分,所以分治开始前都要按照某一个关键字排序,然后利用这个顺序,考虑一个区间[l, r]的两部分间的影响.感觉说的太多,还是不如具体题目分析,而且题目也不尽相同,记住几句话是没什么用的. 练习地址: http://vjudge.net/contest/view.actio